//+------------------------------------------------------------------+
//|                                              Keltner Channel.mq4 |
//|                                                  Coded by Gilani |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//mod2009fxtsd ma hilo
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Red

#property indicator_style1     0
#property indicator_style2     4
#property indicator_style3     4
#property indicator_style4     0


//---- input parameters
extern int    ATRPeriod  = 14;
extern double ATRmultipl = 1.5;

extern int    MA_Period = 13;
extern int    MA_type   = 1;
extern int    MA_shift  = 0;
extern int    MA_Price  = 0;
extern bool   MA_HiLo   = true;


extern string   note_Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   MA_Method_ = "SMA0 EMA1 SMMA2 LWMA3";

//----
double upper[], middle[], middle1[], lower[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, upper);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexShift(0, MA_shift);
   SetIndexDrawBegin(0, 0);
//----
   SetIndexBuffer(1, middle);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexShift(1, MA_shift);
   SetIndexDrawBegin(1, 0);

//----
   SetIndexBuffer(3, lower);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexShift(3, MA_shift);
   SetIndexDrawBegin(3, 0);

string shortn=" MA("+MA_Period+") ATR("+ATRPeriod+") "+DoubleToStr(ATRmultipl,2);

if (MA_HiLo)
   {
   SetIndexBuffer(2, middle1);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexShift(2, MA_shift);
   SetIndexDrawBegin(2, 0);
   SetIndexLabel(1, "KChanMAHi "+shortn); 
   SetIndexLabel(2, "KChanMALo "+shortn); 
   }
   else
   SetIndexLabel(1, "KChanMid " +shortn); 
   

//---- name for DataWindow label
   SetIndexLabel(0, "KCUperBand " +shortn);    
   SetIndexLabel(3, "KCLowerBand " +shortn); 

   IndicatorShortName("KChan "+shortn);  



//----





   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
  {
   int limit;
   double avg, mid1,mid2;   
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)        return(-1);
   if(counted_bars > 0)        counted_bars--;
   limit = Bars - counted_bars;
//----
   for(int x = 0; x < limit; x++) 
     {
      if (MA_HiLo)
      {
      mid1  =  iMA(NULL, 0, MA_Period, MA_shift, MA_type, PRICE_HIGH, x);
      mid2  =  iMA(NULL, 0, MA_Period, MA_shift, MA_type, PRICE_LOW,  x);
      middle [x] =mid1;
      middle1[x] =mid2 ;      
      }
      else
      {
      middle[x]  =  iMA(NULL, 0, MA_Period, MA_shift, MA_type, MA_Price, x);
      mid1=middle[x];
      mid2=middle[x]; 
      }     

      avg  = iATR(NULL,0,ATRPeriod, x)*ATRmultipl;
      
      upper[x] = mid1 + avg;
      lower[x] = mid2 - avg;
      


      
     }
   return(0);
  }
//+------------------------------------------------------------------+


